; 
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Q Beginn der verwendeten Interrupt Service Routinen ( ISR )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;USART Transmit Complete Interrupt
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
; Mit RETI in der Vektorsprungtabelle ist es auch getan
;
;
_UTXCaddr:
; in   s_sreg,SREG           ;Statusregister sichern 

; out  SREG,s_sreg           ;Statusregister wiederherstellen
; reti                       ;Ruecksprung aus der Interrupt Service Routine     
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Timer0 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_OVF0addr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 
 
 sbrs flag_reg,ska.ftg      ;Bit skalieren fertig? -> Springen ueberspringen
 rjmp _exit_OVF0addr          
 out  OCR0B,x_bsh           ;PWM an OC0B erneuern
 cbr  flag_reg,1<<ska.ftg   ;Bit skalieren fertig ruecksetzen
 clr  x_bsh                 ;X-Achse Beschleunigungssensor High-Byte ruecksetzen

_exit_OVF0addr:
 out  SREG,s_sreg           ;Statusregister wiederherstellen
 
 reti                       ;Ruecksprung aus der Timer0 Overflow ISR
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Timer2 Overflow ISR ( Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_OVF2addr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 
;
;Tasterentprellung. Das Bit key.actuated ( Taster betaetigt & entprellt )
;wird nach dem Auswerten in der Hauptprogrammschleife rueckgesetzt.
;
 bst  key_reg,key.unactuated;Taster betaetigt & entprellt im T-Flag speichern 
 sbis KEY_PIN,key.bit       ;Taster unbetaetigt?
 rjmp _actuated             ;Nein => Taster betaetigt
 brts _counterrestore       ;Zaehler auf 4 ruecksetzen
 rjmp _count                ;Bis 3 Zaehlen
_actuated:
 brts _count                ;Weiter von 5 bis 8 zaehlen
_counterrestore:
 cbr  key_reg,$03           ;Zaehlerbits 1&0 ruecksetzen
_count:
 sbrs key_reg,key.actuated  ;Taster betaetigt entprellt?
 inc  key_reg   
;
;ProgrammLaufAnzeige-LED ( PLA-LED ) blinken lassen 
;
 sbrs flag_reg,pla.flg      ;PLA-Flag in der Mainschleife quitiert?...
 rjmp _exit_OVF2addr        ;...Nein => ISR verlassen

 inc  ovf2_zaehler          ;Overflowzaehler inkrementieren...
 sbrs ovf2_zaehler,#ovf2_zaehler;...bis 8 gezaehlt...
 rjmp _exit_OVF2addr        ;...Nein => ISR verlassen
 clr  ovf2_zaehler          ;Overflowzaehler ruecksetzen

 sbi  PLA_PIN, led.pla      ;Programmlaufanzeige LED toggeln
;
;Timer2 Overflow ISR verlassen
; 
_exit_OVF2addr:             ;Timer0 Overflow Interrupt verlassen
 cbr flag_reg,1<<pla.flg    ;Programmlaufanzeige-Flag quitieren

 out  SREG,s_sreg           ;Statusregister wiederherstellen

 reti                       ;Ruecksprung aus der Timer2 Overflow ISR
;
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;Two-Wire Serial Interface ISR ( TWI Interrupt Service Routine )
;QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ
;
_TWIaddr:
 in   s_sreg,SREG           ;CPU-Statusregister sichern 
 push zh                    ;Z-Zeiger..
 push zl                    ;..sichern
;
;TWI-Schritt ueberpruefen
;
 lds  ia,TWSR               ;TWI-Statusregister laden,..
 andi ia,$FC                ;..nichtrelevante Bits ausmaskieren..
 ;lsr  ia                    ;..und in eine.. 
 ;lsr  ia                    ;..TWI-Statusnummer..
 ;lsr  ia                    ;..konvertieren..
 ;cpi  ia,#twi_status_anz    ;..pruefen ob im Zulaessigen Bereich..
 ;brcc _twi_error_anz        ;..NEIN => Fehlerbehandlung noetig
 cpse ia,twi_status_check   ;..passt TWI-Status zur jeweiligen TWI-Aktion?
 rjmp _twi_error_seq        ;NEIN => Fehlerbehandlung noetig

 ;cpi  twi_ablauf_nr,#twi_ablauf_nr_anz; 9
 ;brne _twi_irq_sperren      ;TWI-IRQ sperren und ISR verlassen
 ;cbi  LED_PORT,led.ok       ;TESTWEISE Error-LED einschalten###################
 ;lds  ia,TWCR               ;TESTWEISE TWI-Ablauf stoppen   ###################
 ;cbr  ia,TWINT
 ;sts  TWCR,ia               ;##################################################
 
 rjmp _twi_irq_sperren      ;TWI-IRQ sperren und ISR verlassen
;
;Der TWI-Status passt nicht zur TWI-Aktion.
;
_twi_error_seq:
 sbr  flag_reg,1<<twi.err   ;TWI-ERROR-Flag  f. das Hauptprogramm setzen
 
 rcall _warte_udre          ;TESTZWECKE ####################################### 
 ldi  ia,'S'                ;Testweise ########################################
 sts  UDR0,ia               ;Testweise ########################################

 rcall _warte_udre          ;TESTZWECKE ####################################### 
 lds  ia,TWSR
 sts  UDR0,ia               ;TESTZWECKE ####################################### 
               
 
 rjmp _twi_irq_sperren      ;TWI-IRQ sperren und ISR verlassen
;
;Die Anzahl der maximalen TWI-Status wurde ueberschritten
;
_twi_error_anz:
 sbr  flag_reg,1<<twi.err   ;TWI-ERROR-Flag  f. das Hauptprogramm setzen

 rcall _warte_udre          ;TESTZWECKE ####################################### 
 ldi  ia,'A'                ;Testweise ########################################
 sts  UDR0,ia               ;Testweise ########################################
 
 rcall _warte_udre          ;TESTZWECKE ####################################### 
 lds  ia,TWSR               ;TESTWEISE ########################################
 sts  UDR0,ia               ;TESTWEISE ########################################
;
;Ruecksprung aus der TWI-ISR mit TWI-Interrupt sperren ( TWCR.TWIE=0 ) und 
;dem Wiederherstellen von Registern
;
_twi_irq_sperren:
 lds   ia,TWCR              ;..TWI Kontrollregister laden und..
 andi ia,$7E                ;..nur TWCR.TWIE loeschen, also die TWI-Interrupt..
 sts TWCR,ia                ;..sperren, aber TWINT bleibt f. die Main gesetzt !

 pop  zl                    ;Z-Zeiger..
 pop  zh                    ;..wiederherstellen
 out  SREG,s_sreg           ;CPU-Statusregister wiederherstellen

 reti                       ;Ruecksprung aus der TWI-ISR    